Bug 220348 - rpm seems to have bogus multilib optimization
rpm seems to have bogus multilib optimization
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: rpm (Show other bugs)
5.0
All Linux
medium Severity medium
: ---
: ---
Assigned To: Peter Jones
:
Depends On: 214737
Blocks:
  Show dependency treegraph
 
Reported: 2006-12-20 11:39 EST by Bastien Nocera
Modified: 2010-10-22 03:29 EDT (History)
1 user (show)

See Also:
Fixed In Version: RHBA-2007-0620
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-11-07 12:28:18 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Bastien Nocera 2006-12-20 11:39:46 EST
+++ This bug was initially created as a clone of Bug #214737 +++

Recently a lost of packages that call programs in post have had to add 

[ -x /path/to/program ] && 

guards to get around some sort of optimization that rpm performs where it won't
install a 32-bit binary early in a transaction if a 64-bit binary would
overwrite it later in the transaction.

That optimization seems bogus because the binary may be needed during the
transaction and it breaks the contract that Requires(post): program will ensure
the program is fully installed before %post.

We should just always install the 32-bit binary even though it will get replaced
later in the transaction.
Comment 1 Bastien Nocera 2006-12-20 11:42:37 EST
This causes errors like:

Installing gtk2 - 2.10.4-8.el5.ppc
[...]
Installing gnome-icon-theme - 2.16.0.1-3.el5.noarch
/var/tmp/rpm-tmp.9566: line 4: /usr/bin/gtk-update-icon-cache: No such file or
directory
/var/tmp/rpm-tmp.9566: line 4: /usr/bin/gtk-update-icon-cache: No such file or
directory
/var/tmp/rpm-tmp.9566: line 4: /usr/bin/gtk-update-icon-cache: No such file or
directory
error: %post(gnome-icon-theme-2.16.0.1-3.el5.noarch) scriptlet failed, exit
status 127
[...]
Installing GConf2 - 2.14.0-9.el5.ppc
[...]
Installing notification-daemon - 0.3.5-8.el5.ppc
/var/tmp/rpm-tmp.25424: line 1: gconftool-2: command not found
/var/tmp/rpm-tmp.25424: line 2: gconftool-2: command not found
[...]
Installing metacity - 2.16.0-8.el5.ppc
/var/tmp/rpm-tmp.84362: line 2: gconftool-2: command not found
/var/tmp/rpm-tmp.84362: line 3: gconftool-2: command not found

During a multilib install
Comment 2 Jeff Johnson 2006-12-20 22:01:05 EST
Heh, "bogus multilib optimizations" is not even close to the truth. Sure, let's write
install every ELF file twice just in case it is needed!

FWIW, I have given Paul Nasrat the fix, we'll see if or when it is applied.
Comment 5 RHEL Product and Program Management 2007-03-21 19:14:15 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 7 Jeff Johnson 2007-05-01 08:41:28 EDT
Fixed in rpm cvs, will be in rpm-4.4.9-0.5 when built.

UPSTREAM
Comment 9 Red Hat Bugzilla 2007-08-21 01:30:15 EDT
User pnasrat@redhat.com's account has been closed
Comment 12 errata-xmlrpc 2007-11-07 12:28:18 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2007-0620.html

Note You need to log in before you can comment on or make changes to this bug.